//single player data namespace
var SinglePlayerData = {};
SinglePlayerData.getMapData = function (level) {
    var map = {
        cursorX: 0,
        cursorY: 0,
        width: 15,
        height: 20,
        startingPlayerPositions: [],
        startingEnemyPositions: [],
        terrain: [],
        move: [],
        attack: [],
		vertTerrain: []
    };
	return SinglePlayerData['map' + level](map);
};
SinglePlayerData.getUnitData = function (level) {
	return SinglePlayerData['units' + level]();
};

SinglePlayerData.mapdefault = function (map) { 
    var p = Tr.plain;
    var f = Tr.fort;
    var b = Tr.floor;
    var s = Tr.sea;
    var t = Tr.forest;
    var m = Tr.peak;
	map.width = 15;
	map.height = 20;
	map.vertTerrain.push([p, p, p, p, p, p, m, p, p, p, p, p, p, p, p]);
	map.vertTerrain.push([p, t, m, p, p, p, m, p, p, p, p, p, p, p, p]);
	map.vertTerrain.push([t, t, m, p, p, p, p, p, p, p, p, p, p, p, p]);
	map.vertTerrain.push([t, t, m, f, p, p, p, p, m, m, p, p, p, p, p]);
	map.vertTerrain.push([p, p, t, b, p, p, p, p, m, t, p, p, p, p, p]);
	map.vertTerrain.push([p, f, b, b, b, f, p, p, t, t, p, p, p, p, p]);
	map.vertTerrain.push([m, s, t, b, p, p, p, p, m, t, p, p, m, p, p]);
	map.vertTerrain.push([m, s, s, f, p, p, p, p, m, p, p, m, m, m, p]);
	map.vertTerrain.push([m, s, s, p, p, p, p, p, t, p, p, p, m, p, p]);
	map.vertTerrain.push([s, s, s, m, m, t, p, m, t, t, p, p, p, p, p]);
	map.vertTerrain.push([s, p, p, t, m, t, m, m, t, t, p, m, s, p, p]);
	map.vertTerrain.push([s, s, p, s, m, t, p, f, f, p, m, m, s, s, p]);
	map.vertTerrain.push([s, s, p, s, s, m, p, f, f, m, t, m, s, s, p]);
	map.vertTerrain.push([m, p, p, s, s, m, p, m, m, p, m, s, s, s, p]);
	map.vertTerrain.push([m, m, p, p, p, p, p, p, p, p, p, p, s, s, p]);
	map.vertTerrain.push([t, m, p, p, p, p, p, p, m, p, t, m, p, p, p]);
	map.vertTerrain.push([t, p, p, p, p, p, m, t, t, p, m, t, p, p, p]);
	map.vertTerrain.push([t, t, p, p, p, t, p, p, p, p, t, t, p, p, p]);
	map.vertTerrain.push([t, p, p, p, p, p, p, p, t, p, p, p, p, p, f]);
	map.vertTerrain.push([t, t, p, p, p, t, p, p, t, p, p, p, p, p, f]);
	map.startingPlayerPositions = [{
		x: 14,
		y: 1
	}, {
		x: 13,
		y: 1
	}, {
		x: 14,
		y: 2
	}, {
		x: 13,
		y: 3
	}, {
		x: 12,
		y: 3
	}];
	map.startingEnemyPositions = [{
		x: 4,
		y: 18
	}, {
		x: 3,
		y: 18
	}, {
		x: 3,
		y: 16
	}, {
		x: 3,
		y: 17
	}, {
		x: 2,
		y: 18
	}];
	return map;
};

SinglePlayerData.unitsplayer = function () { 
	var characterArray = [];
    for (var i = 0; i < 5; i += 1) {
        var character = baseStats.createCharacter();
        //perform some lookup, an array of up to 5 objects with:
        character.name = "";
        //cl is to avoid using the word "class"
        if (i == 1) {
            character.cl = "Cavalier";
        } else if (i == 2) {
            character.cl = "Cavalier";
        } else if (i == 3) {
            character.cl = "Archer";
        } else if (i == 4) {
            character.cl = "Archer";
        } else if (i == 0) {
            character.cl = "Knight";
        }
        //copy all base values
		character = baseStats.applyStatsToCharacter(character,character.cl,1);
        character.currentHp = character.hp;
		characterArray.push(character);
    }
    return characterArray;
};

SinglePlayerData.unitsenemy = function () { 
	var characterArray = [];
    for (var i = 0; i < 5; i += 1) {
        var character = baseStats.createCharacter();
        //perform some lookup, an array of up to 5 objects with:
        character.name = "";
        //cl is to avoid using the word "class"
        if (i == 1) {
            character.cl = "Mercenary";
        } else if (i == 2) {
            character.cl = "Mercenary";
        } else if (i == 3) {
            character.cl = "Archer";
        } else if (i == 4) {
            character.cl = "Archer";
        } else if (i == 0) {
            character.cl = "Archer";
        }
        //copy all base values
		character = baseStats.applyStatsToCharacter(character,character.cl,1);
        character.currentHp = character.hp;
		characterArray.push(character);
    }
    return characterArray;
};
