//returns a new empty character that cannot be used
Sy.createEmptyCharacter = function () {
    return {
        "player_state": Sy.NO_PLAYER_STATE
    };
};
Sy.getMap = function (name) {
    var map = {};
    map = SinglePlayerData.getMapData(name);
    //rotate the array
    for (var o = 0; o < map.vertTerrain[0].length; o += 1) {
        map.terrain.push([]);
        for (var r = 0; r < map.vertTerrain.length; r += 1) {
            map.terrain[o].push(map.vertTerrain[r][o]);
        }
    }
    //simple way to clear the map
    map.resetMove = function () {
        map.move = [];
        for (var x = 0; x < map.width; x += 1) {
            map.move.push([]);
            for (var y = 0; y < map.height; y += 1) {
                map.move[x].push(0);
            }
        }
    };
    //simple way to clear the map
    map.resetAttack = function () {
        map.attackSquareColour = "red";
        map.attack = [];
        for (var x = 0; x < map.width; x += 1) {
            map.attack.push([]);
            for (var y = 0; y < map.height; y += 1) {
                map.attack[x].push(0);
            }
        }
    };
    map.resetMove();
    map.resetAttack();
    return map;
};
Sy.getCharacters = function (name) {
    var characterArray = SinglePlayerData.getUnitData(name);
	for(var i=0;i<characterArray.length;i+=1){
	    character = characterArray[i];
		if (name == 'player') {
			character.x = Sy.map.startingPlayerPositions[i].x;
			character.y = Sy.map.startingPlayerPositions[i].y;
			character.player_state = Sy.PLAYER;
		} else {
			character.x = Sy.map.startingEnemyPositions[i].x;
			character.y = Sy.map.startingEnemyPositions[i].y;
			character.player_state = Sy.ENEMY;
		}
		character.item = [Im.ironsword, Im.vulnerary, Im.ironbow, Im.ironlance, Im.ironaxe];
	character.hasMoved = false;
	}
	return characterArray;
};
//prepare browser for HTML elements
Sy.init = function () {
    //clear loading screen
    $("#loading").hide();
    Sy.remoteUnitsLoaded = 0;
    Sy.remotePlayerUnits = {
        "unit1": {},
        "unit2": {},
        "unit3": {},
        "unit4": {},
        "unit5": {}
    }
    Sy.remoteEnemyUnits = {
        "unit1": {},
        "unit2": {},
        "unit3": {},
        "unit4": {},
        "unit5": {}
    }
    //check for if this game was started from a multiplayer session
    
    Sy.playerName = "";
    Sy.enemyName = "";
    Sy.playerId = -1;
	Sy.enemyId = -1;
    Sy.networkBuffer = [];
    Sy.GAME_MODE = GAME_MODES.DEMO;
	Sy.initDemo();
};

Sy.initDemo = function () {
	Sy.PRNG = new MersenneTwister(); //no seed for local play
	Sy.GAME_MODE = GAME_MODES.DEMO;
	Sy.beginGame();
};

Sy.beginGame = function () {
    $(document).keydown(Sy.handleLocalInput);
    //player or enemy
    Sy.PLAYER_STATE = Sy.PLAYER;
    //game data
    Sy.map = Sy.getMap(Sy.mapString);
    Sy.varPlayerCharacters = Sy.getCharacters('player');
    Sy.varEnemyCharacters = Sy.getCharacters('enemy');
	Sy.map.cursorX = Sy.varPlayerCharacters[0].x;
	Sy.map.cursorY = Sy.varPlayerCharacters[0].y
    Sy.varTurnCount = 1;
    //game state constants
    Sy.STATE_DISPLAY_TURN = 0;
    Sy.STATE_IDLE = 1;
    Sy.STATE_DISPLAY_MOVE = 2;
    Sy.STATE_POST_MOVE_MENU = 3;
    Sy.STATE_SELECT_WEAPON_MENU = 4;
    Sy.STATE_SELECT_WEAPON_TARGET = 5;
    Sy.STATE_BATTLE = 6;
    Sy.STATE_SELECT_TRADE_TARGET = 7;
    Sy.STATE_SELECT_STAFF = 8;
    Sy.STATE_SELECT_STAFF_TARGET = 9;
    Sy.STATE_SELECT_STAFF_DESTINATION = 10;
    Sy.STATE_DISPLAY_STAFF_ANIMATION = 11;
    Sy.STATE_POST_MOVE_ITEM_MENU = 12;
    Sy.STATE_DISPLAY_MENU = 13;
    Sy.STATE_DISPLAY_UNITS = 14;
    Sy.STATE_USE_ITEM_ANIMATION = 15;
    Sy.STATE_MOVE_ANIMATION = 16;
    Sy.STATE_GAME_OVER = 17;
    Sy.STATE_TRADE = 18;
    //internal state variables
    Sy.internalStateVar = [];
    for (var i = 0; i <= Sy.STATE_TRADE; i += 1) {
        Sy.internalStateVar[i] = {};
    }
    //keep track of the current game state by using the constants
    Sy.CurrentState = Sy.STATE_DISPLAY_TURN;
    //input buffer (queue)
    //push() and shift() are used to access elements
    //can be written to by AI, network or keyboard input
    Sy.varInputBuffer = [];
    Sy.varRENDER_TURN = true; //set to false to turn off all rendering for a turn
    Sy.varRENDER_STATE = true; //set to false to skip a particular state
    Sy.varLastRenderedState = -1; //set to an invalid state to force rendering
    Sy.varReRenderState = false; //set to true to force the current state to re-render
    //where the buffer should be populated from
    Sy.varCurrentInput = Sy.BUTTON_NONE;
    Sy.varInputSourcePlayer = Sy.INPUT_SOURCE_KEYBOARD;
    Sy.varInputSourceEnemy = Sy.INPUT_SOURCE_AI;
    Sy.AIdata = {};
    Sy.networkSendBuffer = [];
    Sy.networkTimeSinceLastBufferSend = 0;
    //begin
    Sy.gameLoop();
};
Sy.gameLoop = function () {
    Sy.AI();
    Sy.gameLogic();
    Sy.render();
    Sy.varGameTimer = setTimeout(Sy.gameLoop, 20);
};
Sy.gameLogic = function () {
    //perform once to clear anything that may trigger with animations
    Sy.varCurrentInput = Sy.BUTTON_NONE;
    Sy.checkForStateChangeAndChange();
    //consume all the input that has been entered between frames
    //input is consumed one character at a time
    if (Sy.varInputBuffer.length > 0) {
        if (Sy.varInputBuffer[0][0] == Sy.CurrentState) {
            Sy.varCurrentInput = Sy.varInputBuffer.shift()[1]; //consume input
            Sy.checkForStateChangeAndChange();
            Sy.performStateLogic();
        }
    }
};
Sy.checkForStateChangeAndChange = function () {
    switch (Sy.CurrentState) {
    case Sy.STATE_DISPLAY_TURN:
        {
            if (true) { //animation is over
                //check for win
                if (Sy.checkForWin().gameFinished) {
                    Sy.gameOver();
                    Sy.CurrentState = Sy.STATE_GAME_OVER;
                    return;
                }
                //healing terrain
                for (var i = 0; i < Sy.map.height; i += 1) {
                    for (var j = 0; j < Sy.map.width; j += 1) {
                        var ch = Sy.getCharacterAtPosition(j, i);
                        if (ch.player_state == Sy.PLAYER_STATE && Sy.map.terrain[j][i].heal > 0) {
                            if (ch.currentHp < ch.hp) {
                                ch.currentHp += Math.floor(ch.hp * (Sy.map.terrain[j][i].heal / 100));
                                if (ch.currentHp > ch.hp) {
                                    ch.currentHp = ch.hp;
                                }
                            }
                        }
                    }
                }
                Sy.CurrentState = Sy.STATE_IDLE;
                return;
            }
            break;
        }
    case Sy.STATE_IDLE:
        {
            var ch = Sy.getCharacterAtCursor();
            if (Sy.varCurrentInput == Sy.BUTTON_A && ch.player_state == Sy.PLAYER_STATE && ch.hasMoved == false) { //'a' on useable character
                Sy.fillMoveAndAttackForCharacter(ch);
                Sy.internalStateVar[Sy.STATE_IDLE].cursorX = Sy.map.cursorX;
                Sy.internalStateVar[Sy.STATE_IDLE].cursorY = Sy.map.cursorY;
                Sy.CurrentState = Sy.STATE_DISPLAY_MOVE;
                return;
            } else {
                if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a' on nothing
                    Sy.internalStateVar[Sy.STATE_DISPLAY_MENU].selectedOption = 0;
                    Sy.internalStateVar[Sy.STATE_DISPLAY_MENU].menu = ["Units", "Surrender", "End Turn"];
                    Sy.CurrentState = Sy.STATE_DISPLAY_MENU;
                    return;
                }
            }
            break;
        }
    case Sy.STATE_DISPLAY_MOVE:
        {
            var ch = Sy.getCharacterAtCursor();
            var prevCh = Sy.getCharacterAtPosition(Sy.internalStateVar[Sy.STATE_IDLE].cursorX, Sy.internalStateVar[Sy.STATE_IDLE].cursorY);
            if (Sy.varCurrentInput == Sy.BUTTON_A && (ch.player_state == Sy.NO_PLAYER_STATE || (Sy.map.cursorX == prevCh.x && Sy.map.cursorY == prevCh.y)) && Sy.map.move[Sy.map.cursorX][Sy.map.cursorY] != 0) { //'a' on a blue square
                Sy.internalStateVar[Sy.STATE_DISPLAY_MOVE].cursorX = Sy.map.cursorX;
                Sy.internalStateVar[Sy.STATE_DISPLAY_MOVE].cursorY = Sy.map.cursorY;
                Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].path = Sy.getMovementPath(prevCh.x, prevCh.y, Sy.map.cursorX, Sy.map.cursorY)
                Sy.CurrentState = Sy.STATE_MOVE_ANIMATION;
                return;
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.map.cursorX = Sy.internalStateVar[Sy.STATE_IDLE].cursorX;
                Sy.map.cursorY = Sy.internalStateVar[Sy.STATE_IDLE].cursorY;
                Sy.map.resetMove();
                Sy.map.resetAttack();
                Sy.CurrentState = Sy.STATE_IDLE;
                return;
            }
            break;
        }
    case Sy.STATE_MOVE_ANIMATION:
        {
            if (Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].path.length > 0) {
                //play the animation
                Sy.varReRenderState = true;
            } else {
                /*if(false){//unit got a !
        Sy.internalStateVar[Sy.CurrentState].ch.hasMoved=true;
        Sy.CurrentState=Sy.STATE_IDLE;
        //set cursor
        return;
      }*/
                if (true) { //normal move success
                    //update character location to the final spot
                    Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].cursorX = Sy.map.cursorX;
                    Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].cursorY = Sy.map.cursorY;
                    var selectedChX = Sy.internalStateVar[Sy.STATE_IDLE].cursorX;
                    var selectedChY = Sy.internalStateVar[Sy.STATE_IDLE].cursorY;
                    var ch = Sy.getCharacterAtPosition(selectedChX, selectedChY);
                    ch.x = Sy.map.cursorX;
                    ch.y = Sy.map.cursorY;
                    Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].ch = ch;
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_MENU].selectedOption = 0;
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_MENU].menu = [Sy.MENU_WAIT];
                    //check for trade target
                    var nextToArr = Sy.getCharactersNextTo(ch);
                    if (nextToArr.length > 0) {
                        Sy.internalStateVar[Sy.STATE_POST_MOVE_MENU].menu.push(Sy.MENU_TRADE);
                    }
                    for (var c = 0; c < 5; c += 1) {
                        var item = Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].ch.item[c];
                        var menu = Sy.internalStateVar[Sy.STATE_POST_MOVE_MENU].menu;
                        if (item.menu_option.length > 0) {
                            var addToMenu = true;
                            for (var i = 0; i < menu.length; i += 1) {
                                if (menu[i] == item.menu_option) {
                                    addToMenu = false;
                                    break;
                                }
                            }
                            if (item.menu_option == Sy.MENU_ATTACK && addToMenu == true) {
                                //search for enemies in range, otherwise remove this option
                                Sy.map.resetAttack();
                                Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                var enemy = Sy.ENEMY;
                                if (Sy.PLAYER_STATE == enemy) {
                                    enemy = Sy.PLAYER;
                                }
                                if (Sy.getUnitsInWeaponRange(enemy).length > 0) {
                                    addToMenu = true;
                                } else {
                                    addToMenu = false;
                                }
                                if (ch[item.kind + "_exp"] < item.rank) {
                                    addToMenu = false;
                                }
                            }
                            if (item.menu_option == Sy.MENU_STAFF && addToMenu == true) {
                                //search for allys in range, otherwise remove this option
                                Sy.map.resetAttack();
                                Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                if (Sy.getUnitsInWeaponRange(Sy.PLAYER_STATE).length > 0) {
                                    addToMenu = true;
                                } else {
                                    addToMenu = false;
                                }
                                if (ch[item.kind + "_exp"] < item.rank) {
                                    addToMenu = false;
                                }
                            }
                            if (addToMenu) {
                                menu.push(item.menu_option);
                            }
                        }
                    }
                    Sy.map.resetMove();
                    Sy.map.resetAttack();
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_MENU].menu.sort();
                    Sy.CurrentState = Sy.STATE_POST_MOVE_MENU;
                    return;
                }
            }
            break;
        }
    case Sy.STATE_POST_MOVE_MENU:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) {
                var menu = Sy.internalStateVar[Sy.STATE_POST_MOVE_MENU].menu;
                var option = Sy.internalStateVar[Sy.STATE_POST_MOVE_MENU].selectedOption;
                var sel = menu[option];
                if (sel == Sy.MENU_ATTACK) { //'a' on 'attack'
                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].menu = [];
                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].selectedOption = 0;
                    var ch = Sy.getCharacterAtCursor();
                    var itemIndex = -1;
                    for (var c = 0; c < 5; c += 1) {
                        var item = ch.item[c];
                        if (item.menu_option.length > 0) {
                            Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].menu.push(item.name);
                            if (itemIndex == -1 && item.menu_option == Sy.MENU_ATTACK && ch[item.kind + "_exp"] >= item.rank) {
                                Sy.map.resetAttack();
                                Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                var enemy = Sy.ENEMY;
                                if (Sy.PLAYER_STATE == enemy) {
                                    enemy = Sy.PLAYER;
                                }
                                var inRange = Sy.getUnitsInWeaponRange(enemy);
                                Sy.map.resetAttack();
                                if (inRange.length > 0) {
                                    itemIndex = c;
                                    Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                }
                            }
                        }
                    }
                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].selectedOption = itemIndex;
                    Sy.CurrentState = Sy.STATE_SELECT_WEAPON_MENU;
                    return;
                }
                if (sel == Sy.MENU_ITEM) { //'a' on 'item'
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].menu = [];
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].selectedOption = 0;
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList = true;
                    var ch = Sy.getCharacterAtCursor();
                    for (var c = 0; c < 5; c += 1) {
                        var item = ch.item[c];
                        if (item.menu_option.length > 0) {
                            Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].menu.push(item.name);
                        }
                    }
                    Sy.CurrentState = Sy.STATE_POST_MOVE_ITEM_MENU;
                    return;
                }
                if (sel == Sy.MENU_STAFF) { //'a' on 'staff'
                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF].menu = [];
                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF].selectedOption = 0;
                    var ch = Sy.getCharacterAtCursor();
                    var itemIndex = -1;
                    for (var c = 0; c < 5; c += 1) {
                        var item = ch.item[c];
                        if (item.menu_option.length > 0) {
                            Sy.internalStateVar[Sy.STATE_SELECT_STAFF].menu.push(item.name);
                            if (itemIndex == -1 && item.menu_option == Sy.MENU_STAFF && ch[item.kind + "_exp"] >= item.rank) {
                                Sy.map.resetAttack();
                                Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                var inRange = Sy.getUnitsInWeaponRange(Sy.PLAYER_STATE);
                                Sy.map.resetAttack();
                                if (inRange.length > 0) {
                                    itemIndex = c;
                                }
                            }
                        }
                    }
                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF].selectedOption = itemIndex;
                    Sy.CurrentState = Sy.STATE_SELECT_STAFF;
                    return;
                }
                if (sel == Sy.MENU_TRADE) { //'a' on 'trade'
                    Sy.CurrentState = Sy.STATE_SELECT_TRADE_TARGET;
                    var ch = Sy.getCharacterAtCursor();
                    Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].ch = ch;
                    Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex = 0;
                    Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].inRange = Sy.getCharactersNextTo(ch);
                    return;
                }
                if (sel == Sy.MENU_WAIT) { //'a' on 'wait'
                    var ch = Sy.getCharacterAtPosition(Sy.map.cursorX, Sy.map.cursorY);
                    ch.hasMoved = true;
                    Sy.map.resetMove();
                    Sy.CurrentState = Sy.STATE_IDLE;
                    return;
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                var selectedChX = Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].cursorX
                var selectedChY = Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].cursorY
                var ch = Sy.getCharacterAtPosition(selectedChX, selectedChY);
                ch.x = Sy.internalStateVar[Sy.STATE_IDLE].cursorX;
                ch.y = Sy.internalStateVar[Sy.STATE_IDLE].cursorY;
                Sy.fillMoveAndAttackForCharacter(ch);
                Sy.CurrentState = Sy.STATE_DISPLAY_MOVE;
                return;
            }
            break;
        }
    case Sy.STATE_SELECT_WEAPON_MENU:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a' on valid weapon
                var ch = Sy.getCharacterAtCursor();
                var itemIndex = 0;
                //translate menu option back into item choice
                for (var c = 0; c < 5; c += 1) {
                    var item = ch.item[c];
                    if (item.menu_option.length > 0) {
                        if (itemIndex == Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].selectedOption) {
                            //found the item, now check for validity
                            if (item.menu_option == Sy.MENU_ATTACK && ch[item.kind + "_exp"] >= item.rank) {
                                Sy.map.resetAttack();
                                Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                var enemy = Sy.ENEMY;
                                if (Sy.PLAYER_STATE == enemy) {
                                    enemy = Sy.PLAYER;
                                }
                                var inRange = Sy.getUnitsInWeaponRange(enemy);
                                Sy.map.resetAttack();
                                //swap to be the first item
                                var swapItem = ch.item[0];
                                ch.item[0] = ch.item[c];
                                ch.item[c] = swapItem;
                                var swapMenu = Sy.internalStateVar[Sy.CurrentState].menu[0];
                                Sy.internalStateVar[Sy.CurrentState].menu[0] = Sy.internalStateVar[Sy.CurrentState].menu[Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].selectedOption];
                                Sy.internalStateVar[Sy.CurrentState].menu[Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].selectedOption] = swapMenu;
                                Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_MENU].selectedOption = 0;
                                if (inRange.length > 0) {
                                    Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].character = ch;
                                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].weapon = item;
                                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex = 0;
                                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].inRange = inRange;
                                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].cursorX = Sy.map.cursorX;
                                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].cursorY = Sy.map.cursorY;
                                    Sy.CurrentState = Sy.STATE_SELECT_WEAPON_TARGET;
                                    return;
                                }
                            }
                            break;
                        }
                        itemIndex += 1;
                    }
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.CurrentState = Sy.STATE_POST_MOVE_MENU;
                return;
            }
            break;
        }
    case Sy.STATE_SELECT_WEAPON_TARGET:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a' on target
                var ch = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].character;
                var item = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].weapon;
                var i = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex;
                var enemy = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].inRange[i];
                Sy.internalStateVar[Sy.STATE_BATTLE].character = ch;
                Sy.internalStateVar[Sy.STATE_BATTLE].weapon = item;
                Sy.internalStateVar[Sy.STATE_BATTLE].enemy = enemy;
                Sy.internalStateVar[Sy.STATE_BATTLE].animationIsOver = false;
                Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack = [];
                Sy.map.resetAttack();
                var enemyWeapon = Sy.getFirstUseableWeapon(Sy.internalStateVar[Sy.STATE_BATTLE].enemy, Sy.internalStateVar[Sy.STATE_BATTLE].character);
                Sy.internalStateVar[Sy.STATE_BATTLE].enemyWeapon = enemyWeapon;
                var preview = Sy.battlePreview(Sy.internalStateVar[Sy.STATE_BATTLE].character, Sy.internalStateVar[Sy.STATE_BATTLE].weapon, Sy.internalStateVar[Sy.STATE_BATTLE].enemy, Sy.internalStateVar[Sy.STATE_BATTLE].enemyWeapon);
                Sy.internalStateVar[Sy.STATE_BATTLE].battlePreview = preview;
                Sy.internalStateVar[Sy.STATE_BATTLE].waitForCutscene = false;
                Sy.CurrentState = Sy.STATE_BATTLE;
                return;
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.map.resetAttack();
                Sy.map.cursorX = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].cursorX;
                Sy.map.cursorY = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].cursorY;
                Sy.CurrentState = Sy.STATE_SELECT_WEAPON_MENU;
                return;
            }
            break;
        }
    case Sy.STATE_BATTLE:
        {
            //cutscene is playing, wait for it to finish.
            if (Sy.internalStateVar[Sy.STATE_BATTLE].waitForCutscene) {
                break;
            }
            Sy.varReRenderState = true; //needs constant redraw
            if (Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack.length == 0 && !(Sy.internalStateVar[Sy.STATE_BATTLE].animationIsOver)) { //animation started
                var preview = Sy.internalStateVar[Sy.STATE_BATTLE].battlePreview;
                var battle = Sy.performBattleCalculation(Sy.internalStateVar[Sy.STATE_BATTLE].character, Sy.internalStateVar[Sy.STATE_BATTLE].weapon, Sy.internalStateVar[Sy.STATE_BATTLE].enemy, Sy.internalStateVar[Sy.STATE_BATTLE].enemyWeapon);
                Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation = battle;
                preview.player.rounds = battle.player.rounds;
                preview.enemy.rounds = battle.enemy.rounds;
                var maxRounds = preview.player.rounds + preview.enemy.rounds;
                var i = 0
                while (i < maxRounds) {
                    if (preview.player.rounds > 0) {
                        var data = {
                            side: Sy.PLAYER_STATE,
                            weapon: preview.player.weapon,
                            cl: Sy.internalStateVar[Sy.STATE_BATTLE].character.cl,
                            enemy: Sy.internalStateVar[Sy.STATE_BATTLE].enemy.cl,
                            desc: battle.player.desc.shift()
                        };
                        Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack.push(data);
                        preview.player.rounds -= 1;
                        i += 1;
                    }
                    if (preview.enemy.rounds > 0) {
                        var data = {
                            side: Sy.NO_PLAYER_STATE,
                            weapon: preview.enemy.weapon,
                            cl: Sy.internalStateVar[Sy.STATE_BATTLE].enemy.cl,
                            enemy: Sy.internalStateVar[Sy.STATE_BATTLE].character.cl,
                            desc: battle.enemy.desc.shift()
                        };
                        Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack.push(data);
                        preview.enemy.rounds -= 1;
                        i += 1;
                    }
                }
            }
            if (Sy.internalStateVar[Sy.STATE_BATTLE].animationIsOver) { //animation over
                ch = Sy.internalStateVar[Sy.STATE_BATTLE].character;
                Sy.map.cursorX = ch.x;
                Sy.map.cursorY = ch.y;
                ch.hasMoved = true;
                Sy.CurrentState = Sy.STATE_IDLE;
                return;
            }
            break;
        }
    case Sy.STATE_SELECT_TRADE_TARGET:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a' on target
                var target = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].inRange[Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex];
                Sy.internalStateVar[Sy.STATE_TRADE].fromCh = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].ch;
                Sy.internalStateVar[Sy.STATE_TRADE].toCh = target;
                Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex = 0;
                Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex = -1;
                Sy.CurrentState = Sy.STATE_TRADE;
                return;
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.map.cursorX = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].ch.x;
                Sy.map.cursorY = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].ch.y;
                Sy.CurrentState = Sy.STATE_POST_MOVE_MENU;
                return;
            }
            break;
        }
    case Sy.STATE_SELECT_STAFF:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a' on valid staff
                var ch = Sy.getCharacterAtCursor();
                var itemIndex = 0;
                //translate menu option back into item choice
                for (var c = 0; c < 5; c += 1) {
                    var item = ch.item[c];
                    if (item.menu_option.length > 0) {
                        if (itemIndex == Sy.internalStateVar[Sy.STATE_SELECT_STAFF].selectedOption) {
                            //found the item, now check for validity
                            if (item.menu_option == Sy.MENU_STAFF) {
                                Sy.map.resetAttack();
                                Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                var inRange = Sy.getUnitsInWeaponRange(Sy.PLAYER_STATE);
                                Sy.map.resetAttack();
                                Sy.map.attackSquareColour = "green";
                                if (inRange.length > 0) {
                                    Sy.fillAttack(ch.x, ch.y, item.min_range, item.max_range);
                                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].character = ch;
                                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].item = item;
                                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex = 0;
                                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].inRange = inRange;
                                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].cursorX = Sy.map.cursorX;
                                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].cursorY = Sy.map.cursorY;
                                    Sy.CurrentState = Sy.STATE_SELECT_STAFF_TARGET;
                                    return;
                                }
                            }
                            break;
                        }
                        itemIndex += 1;
                    }
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.CurrentState = Sy.STATE_POST_MOVE_MENU;
                return;
            }
            break;
        }
    case Sy.STATE_SELECT_STAFF_TARGET:
        {
            /*if(false){//'a' with warp
        Sy.CurrentState=Sy.STATE_SELECT_STAFF_DESTINATION;
        return;
      }*/
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a' with heal
                var ch = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].character;
                var item = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].item;
                var i = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex;
                var target = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].inRange[i];
                Sy.internalStateVar[Sy.STATE_DISPLAY_STAFF_ANIMATION].source = ch;
                Sy.internalStateVar[Sy.STATE_DISPLAY_STAFF_ANIMATION].item = item;
                Sy.internalStateVar[Sy.STATE_DISPLAY_STAFF_ANIMATION].target = target;
                Sy.CurrentState = Sy.STATE_DISPLAY_STAFF_ANIMATION;
                return;
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.map.resetAttack();
                Sy.map.cursorX = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].character.x;
                Sy.map.cursorY = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].character.y;
                Sy.CurrentState = Sy.STATE_SELECT_STAFF;
                return;
            }
            break;
        }
    case Sy.STATE_SELECT_STAFF_DESTINATION:
        {
            /*if(false){//'a' on valid destination
        Sy.CurrentState=Sy.STATE_DISPLAY_STAFF_ANIMATION;
        return;
      }*/
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.CurrentState = Sy.STATE_SELECT_STAFF_TARGET;
                return;
            }
            break;
        }
    case Sy.STATE_DISPLAY_STAFF_ANIMATION:
        {
            if (true) { //animation over
                var source = Sy.internalStateVar[Sy.STATE_DISPLAY_STAFF_ANIMATION].source;
                var item = Sy.internalStateVar[Sy.STATE_DISPLAY_STAFF_ANIMATION].item;
                var target = Sy.internalStateVar[Sy.STATE_DISPLAY_STAFF_ANIMATION].target;
                //do staff stuff
                Sy.useStaff(source, target, item);
                source.hasMoved = true;
                Sy.map.resetAttack();
                Sy.map.cursorX = source.x;
                Sy.map.cursorY = source.y;
                Sy.CurrentState = Sy.STATE_IDLE;
                return;
            }
            break;
        }
    case Sy.STATE_POST_MOVE_ITEM_MENU:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a' on an item
                //Sy.MENU_ITEM
                //Sy.MENU_ATTACK
                if (Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList == true) { //show "use, equip, etc" menu
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemOptions = "";
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemSelected = {};
                    var ch = Sy.getCharacterAtCursor();
                    var itemIndex = 0;
                    //translate menu option back into item choice
                    for (var c = 0; c < 5; c += 1) {
                        var item = ch.item[c];
                        if (item.menu_option.length > 0) {
                            if (itemIndex == Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].selectedOption) {
                                //found the item, now check for validity
                                if (item.menu_option == Sy.MENU_ITEM) {
                                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemOptions = "Use";
                                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemSelected = item;
                                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList = false;
                                    Sy.varReRenderState = true;
                                    break;
                                }
                                if (item.menu_option == Sy.MENU_ATTACK && ch[item.kind + "_exp"] >= item.rank) {
                                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemOptions = "Equip";
                                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemSelected = item;
                                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemSelectedIndex = c;
                                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList = false;
                                    Sy.varReRenderState = true;
                                    break;
                                }
                            }
                            itemIndex += 1;
                        }
                    }
                } else { //in the "use, equip, etc" menu
                    if (Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemOptions == "Use") {
                        Sy.internalStateVar[Sy.STATE_USE_ITEM_ANIMATION].character = Sy.getCharacterAtCursor();
                        Sy.internalStateVar[Sy.STATE_USE_ITEM_ANIMATION].item = Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemSelected;
                        Sy.CurrentState = Sy.STATE_USE_ITEM_ANIMATION;
                        return;
                    }
                    if (Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemOptions == "Equip") {
                        var ch = Sy.getCharacterAtCursor();
                        var c = Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemSelectedIndex;
                        var swapItem = ch.item[0];
                        ch.item[0] = ch.item[c];
                        ch.item[c] = swapItem;
                        var swapMenu = Sy.internalStateVar[Sy.CurrentState].menu[0];
                        Sy.internalStateVar[Sy.CurrentState].menu[0] = Sy.internalStateVar[Sy.CurrentState].menu[Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].selectedOption];
                        Sy.internalStateVar[Sy.CurrentState].menu[Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].selectedOption] = swapMenu;
                        Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].selectedOption = 0;
                        Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList = true; //back out of "use, equip, etc" menu
                        Sy.varReRenderState = true;
                    }
                }
                /*
        var ch=Sy.getCharacterAtCursor();
        var itemIndex=0;
        //translate menu option back into item choice
        for(var c=0;c<5;c+=1){
          var item=ch.item[c];
          if(item.menu_option.length>0){
            if(itemIndex==Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].selectedOption){
              //found the item, now check for validity
              if(item.menu_option==Sy.MENU_ITEM){
                Sy.internalStateVar[Sy.STATE_USE_ITEM_ANIMATION].character=ch;
                Sy.internalStateVar[Sy.STATE_USE_ITEM_ANIMATION].item=item;
                Sy.CurrentState=Sy.STATE_USE_ITEM_ANIMATION;
                return;
              }
            }
            itemIndex+=1;
          }
        }*/
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                if (Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList == true) { //back out of state
                    Sy.CurrentState = Sy.STATE_POST_MOVE_MENU;
                } else {
                    Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList = true; //back out of "use, equip, etc" menu
                    Sy.varReRenderState = true;
                }
                return;
            }
            break;
        }
    case Sy.STATE_USE_ITEM_ANIMATION:
        {
            if (true) { //animtaion over
                var ch = Sy.internalStateVar[Sy.STATE_USE_ITEM_ANIMATION].character;
                var item = Sy.internalStateVar[Sy.STATE_USE_ITEM_ANIMATION].item;
                //do item stuff
                Sy.useItem(ch, item);
                ch.hasMoved = true;
                Sy.CurrentState = Sy.STATE_IDLE;
                return;
            }
            break;
        }
    case Sy.STATE_DISPLAY_MENU:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //a
                if (Sy.internalStateVar[Sy.STATE_DISPLAY_MENU].selectedOption == 0) {
                    //units
                    Sy.CurrentState = Sy.STATE_DISPLAY_UNITS;
                    return;
                }
                if (Sy.internalStateVar[Sy.STATE_DISPLAY_MENU].selectedOption == 1) {
                    //surrender
                    //kill all player units and go to game over
                    if (Sy.PLAYER_STATE == Sy.PLAYER) {
                        for (var i = 0; i < Sy.varPlayerCharacters.length; i += 1) {
                            Sy.varPlayerCharacters[i].currentHp = -1;
                        }
                    } else {
                        for (var i = 0; i < Sy.varEnemyCharacters.length; i += 1) {
                            Sy.varEnemyCharacters[i].currentHp = -1;
                        }
                    }
                    Sy.gameOver();
                    Sy.CurrentState = Sy.STATE_GAME_OVER;
                    return;
                }
                if (Sy.internalStateVar[Sy.STATE_DISPLAY_MENU].selectedOption == 2) {
                    //end turn
                    //reset moved units
                    for (var i = 0; i < Sy.varPlayerCharacters.length; i += 1) {
                        if (Sy.varPlayerCharacters[i].hasMoved) {
                            Sy.varPlayerCharacters[i].hasMoved = false;
                        }
                    }
                    for (var i = 0; i < Sy.varEnemyCharacters.length; i += 1) {
                        if (Sy.varEnemyCharacters[i].hasMoved) {
                            Sy.varEnemyCharacters[i].hasMoved = false;
                        }
                    }
                    //toggle the player
                    if (Sy.PLAYER_STATE == Sy.PLAYER) {
                        Sy.PLAYER_STATE = Sy.ENEMY;
                    } else {
                        Sy.PLAYER_STATE = Sy.PLAYER;
                        Sy.varTurnCount += 1; //turn count only goes up on end of enemy turn
                    }
                    //show transition
                    Sy.CurrentState = Sy.STATE_DISPLAY_TURN;
                    return;
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.CurrentState = Sy.STATE_IDLE;
                return;
            }
            break;
        }
    case Sy.STATE_DISPLAY_UNITS:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                Sy.CurrentState = Sy.STATE_DISPLAY_MENU;
                return;
            }
            break;
        }
    case Sy.STATE_GAME_OVER:
        {
            break;
        }
    case Sy.STATE_TRADE:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_A) { //'a'
                if (Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex == -1) { //no 2nd item selected
                    Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex = 0;
                    Sy.varReRenderState = true;
                } else {
                    //perform trade
                    var fromIndex = Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex;
                    var toIndex = Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex;
                    var fromItem = Sy.internalStateVar[Sy.STATE_TRADE].fromCh.item[fromIndex];
                    Sy.internalStateVar[Sy.STATE_TRADE].fromCh.item[fromIndex] = Sy.internalStateVar[Sy.STATE_TRADE].toCh.item[toIndex];
                    Sy.internalStateVar[Sy.STATE_TRADE].toCh.item[toIndex] = fromItem;
                    Sy.varReRenderState = true;
                    Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex = -1;
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_B) { //'b'
                if (Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex == -1) { //no 2nd item selected
                    Sy.map.cursorX = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].ch.x;
                    Sy.map.cursorY = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].ch.y;
                    Sy.CurrentState = Sy.STATE_POST_MOVE_MENU;
                } else { //item selected, back out of selection
                    Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex = -1;
                    Sy.varReRenderState = true;
                }
                return;
            }
            break;
        }
    }
}
//handles game logic for arrow keys which cannot alter the states
//also handles cases where a/b do not change state
Sy.performStateLogic = function () {
    switch (Sy.CurrentState) {
    case Sy.STATE_DISPLAY_TURN:
        {
            //nothing happens here since it's just displaying an animation
            break;
        }
    case Sy.STATE_IDLE:
        {
            Sy.mapScroll();
            var ch = Sy.getCharacterAtCursor();
            if (ch.player_state != Sy.NO_PLAYER_STATE && ch.player_state != Sy.PLAYER_STATE) {
                Sy.map.resetMove();
                Sy.map.resetAttack();
                Sy.fillMoveAndAttackForCharacter(ch);
                Sy.varReRenderState = true;
            } else {
                Sy.map.resetMove();
                Sy.map.resetAttack();
            }
            break;
        }
    case Sy.STATE_DISPLAY_MOVE:
        {
            Sy.mapScroll();
            break;
        }
    case Sy.STATE_POST_MOVE_MENU:
        {
            Sy.menuScroll();
            break;
        }
    case Sy.STATE_SELECT_WEAPON_MENU:
        {
            Sy.menuScroll();
            break;
        }
    case Sy.STATE_SELECT_WEAPON_TARGET:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_UP || Sy.varCurrentInput == Sy.BUTTON_RIGHT) {
                Sy.varReRenderState = true;
                if (Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex > 0) {
                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex -= 1;
                } else {
                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].inRange.length - 1;
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_DOWN || Sy.varCurrentInput == Sy.BUTTON_LEFT) {
                Sy.varReRenderState = true;
                if (Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex < Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].inRange.length - 1) {
                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex += 1;
                } else {
                    Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex = 0;
                }
            }
            var index = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex;
            var inRange = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].inRange;
            Sy.map.cursorX = inRange[index].x;
            Sy.map.cursorY = inRange[index].y;
            break;
        }
    case Sy.STATE_BATTLE:
        {
            break;
        }
    case Sy.STATE_SELECT_TRADE_TARGET:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_UP || Sy.varCurrentInput == Sy.BUTTON_RIGHT) {
                Sy.varReRenderState = true;
                if (Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex > 0) {
                    Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex -= 1;
                } else {
                    Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].inRange.length - 1;
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_DOWN || Sy.varCurrentInput == Sy.BUTTON_LEFT) {
                Sy.varReRenderState = true;
                if (Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex < Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].inRange.length - 1) {
                    Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex += 1;
                } else {
                    Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex = 0;
                }
            }
            var index = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].tradeIndex;
            var inRange = Sy.internalStateVar[Sy.STATE_SELECT_TRADE_TARGET].inRange;
            Sy.map.cursorX = inRange[index].x;
            Sy.map.cursorY = inRange[index].y;
            break;
        }
    case Sy.STATE_SELECT_STAFF:
        {
            Sy.menuScroll();
            break;
        }
    case Sy.STATE_SELECT_STAFF_TARGET:
        {
            if (Sy.varCurrentInput == Sy.BUTTON_UP || Sy.varCurrentInput == Sy.BUTTON_RIGHT) {
                Sy.varReRenderState = true;
                if (Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex > 0) {
                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex -= 1;
                } else {
                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].inRange.length - 1;
                }
            }
            if (Sy.varCurrentInput == Sy.BUTTON_DOWN || Sy.varCurrentInput == Sy.BUTTON_LEFT) {
                Sy.varReRenderState = true;
                if (Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex < Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].inRange.length - 1) {
                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex += 1;
                } else {
                    Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex = 0;
                }
            }
            var index = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].targetIndex;
            var inRange = Sy.internalStateVar[Sy.STATE_SELECT_STAFF_TARGET].inRange;
            Sy.map.cursorX = inRange[index].x;
            Sy.map.cursorY = inRange[index].y;
            break;
        }
    case Sy.STATE_SELECT_STAFF_DESTINATION:
        {
            break;
        }
    case Sy.STATE_DISPLAY_STAFF_ANIMATION:
        {
            break;
        }
    case Sy.STATE_POST_MOVE_ITEM_MENU:
        {
            if (Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList == true) {
                Sy.menuScroll();
            }
            break;
        }
    case Sy.STATE_USE_ITEM_ANIMATION:
        {
            break;
        }
    case Sy.STATE_DISPLAY_MENU:
        {
            Sy.menuScroll();
            break;
        }
    case Sy.STATE_DISPLAY_UNITS:
        {
            break;
        }
    case Sy.STATE_GAME_OVER:
        {
            break;
        }
    case Sy.STATE_TRADE:
        {
            if (Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex == -1) { //haven't selected first weapon
                if (Sy.varCurrentInput == Sy.BUTTON_DOWN || Sy.varCurrentInput == Sy.BUTTON_LEFT) {
                    Sy.varReRenderState = true;
                    Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex += 1;
                    if (Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex >= 5) {
                        Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex = 0;
                    }
                }
                if (Sy.varCurrentInput == Sy.BUTTON_UP || Sy.varCurrentInput == Sy.BUTTON_RIGHT) {
                    Sy.varReRenderState = true;
                    Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex -= 1;
                    if (Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex < 0) {
                        Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex = 4;
                    }
                }
            } else {
                if (Sy.varCurrentInput == Sy.BUTTON_DOWN || Sy.varCurrentInput == Sy.BUTTON_LEFT) {
                    Sy.varReRenderState = true;
                    Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex += 1;
                    if (Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex >= 5) {
                        Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex = 0;
                    }
                }
                if (Sy.varCurrentInput == Sy.BUTTON_UP || Sy.varCurrentInput == Sy.BUTTON_RIGHT) {
                    Sy.varReRenderState = true;
                    Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex -= 1;
                    if (Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex < 0) {
                        Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex = 4;
                    }
                }
            }
        }
    }
};
//returns the index in the player or enemy array that a given character has
Sy.getCharacterIndex = function (ch) {
    if (ch.player_state == Sy.PLAYER) {
        for (var i = 0; i < Sy.varPlayerCharacters.length; i += 1) {
            if (Sy.varPlayerCharacters[i] == ch) {
                return i;
            }
        }
    } else {
        for (var i = 0; i < Sy.varEnemyCharacters.length; i += 1) {
            if (Sy.varEnemyCharacters[i] == ch) {
                return i;
            }
        }
    }
    return -1;
};
//returns an object with information on if the game is over, and who won.
Sy.checkForWin = function () {
    var retVar = {
        gameFinished: false,
        youWin: true
    };
    var noPlayerUnitsLeft = true;
    var noEnemyUnitsLeft = true;
    for (var i = 0; i < Sy.varPlayerCharacters.length; i += 1) {
        if (Sy.varPlayerCharacters[i].currentHp > 0) {
            noPlayerUnitsLeft = false;
        }
    }
    for (var i = 0; i < Sy.varEnemyCharacters.length; i += 1) {
        if (Sy.varEnemyCharacters[i].currentHp > 0) {
            noEnemyUnitsLeft = false;
        }
    }
    if (noPlayerUnitsLeft == true || noEnemyUnitsLeft == true) {
        retVar.gameFinished = true;
    }
    if (noPlayerUnitsLeft) {
        retVar.youWin = false; //default local player lost
    }
    if (noEnemyUnitsLeft) {
        retVar.youWin = true; //default local player lost
    }
    return retVar;
};
//handle win/loss
Sy.gameOver = function () {
	var check = Sy.checkForWin();
	window.close();
};
//handle map scrolling
Sy.mapScroll = function () {
    if (Sy.varCurrentInput == Sy.BUTTON_LEFT) {
        if (Sy.map.cursorX > 0) {
            Sy.map.cursorX -= 1;
            Sy.varReRenderState = true;
        }
    }
    if (Sy.varCurrentInput == Sy.BUTTON_UP) {
        if (Sy.map.cursorY > 0) {
            Sy.map.cursorY -= 1;
            Sy.varReRenderState = true;
        }
    }
    if (Sy.varCurrentInput == Sy.BUTTON_RIGHT) {
        if (Sy.map.cursorX < Sy.map.width - 1) {
            Sy.map.cursorX += 1;
            Sy.varReRenderState = true;
        }
    }
    if (Sy.varCurrentInput == Sy.BUTTON_DOWN) {
        if (Sy.map.cursorY < Sy.map.height - 1) {
            Sy.map.cursorY += 1;
            Sy.varReRenderState = true;
        }
    }
};
//handle menu scrolling
Sy.menuScroll = function () {
    if (Sy.varCurrentInput == Sy.BUTTON_UP) {
        Sy.varReRenderState = true;
        if (Sy.internalStateVar[Sy.CurrentState].selectedOption > 0) {
            Sy.internalStateVar[Sy.CurrentState].selectedOption -= 1;
        } else {
            Sy.internalStateVar[Sy.CurrentState].selectedOption = Sy.internalStateVar[Sy.CurrentState].menu.length - 1;
        }
    }
    if (Sy.varCurrentInput == Sy.BUTTON_DOWN) {
        Sy.varReRenderState = true;
        if (Sy.internalStateVar[Sy.CurrentState].selectedOption < Sy.internalStateVar[Sy.CurrentState].menu.length - 1) {
            Sy.internalStateVar[Sy.CurrentState].selectedOption += 1;
        } else {
            Sy.internalStateVar[Sy.CurrentState].selectedOption = 0;
        }
    }
};
//returns an array of characters of the same player immediatly next to a given character
Sy.getCharactersNextTo = function (ch) {
    var retArr = [];
    if (ch.x + 1 < Sy.map.width) {
        var checkCh = Sy.getCharacterAtPosition(ch.x + 1, ch.y);
        if (checkCh.player_state == ch.player_state) {
            retArr.push(checkCh);
        }
    }
    if (ch.x > 0) {
        var checkCh = Sy.getCharacterAtPosition(ch.x - 1, ch.y);
        if (checkCh.player_state == ch.player_state) {
            retArr.push(checkCh);
        }
    }
    if (ch.y + 1 < Sy.map.height) {
        var checkCh = Sy.getCharacterAtPosition(ch.x, ch.y + 1);
        if (checkCh.player_state == ch.player_state) {
            retArr.push(checkCh);
        }
    }
    if (ch.y > 0) {
        var checkCh = Sy.getCharacterAtPosition(ch.x, ch.y - 1);
        if (checkCh.player_state == ch.player_state) {
            retArr.push(checkCh);
        }
    }
    return retArr;
}
//returns a character at the given cursor location
Sy.getCharacterAtCursor = function () {
    return Sy.getCharacterAtPosition(Sy.map.cursorX, Sy.map.cursorY);
};
//returns a character at an arbitrary location
Sy.getCharacterAtPosition = function (x, y) {
    for (var i = 0; i < Sy.varPlayerCharacters.length; i += 1) {
        if (Sy.varPlayerCharacters[i].x == x && Sy.varPlayerCharacters[i].y == y && Sy.varPlayerCharacters[i].player_state != Sy.NO_PLAYER_STATE) {
            return Sy.varPlayerCharacters[i];
        }
    }
    for (var i = 0; i < Sy.varEnemyCharacters.length; i += 1) {
        if (Sy.varEnemyCharacters[i].x == x && Sy.varEnemyCharacters[i].y == y && Sy.varEnemyCharacters[i].player_state != Sy.NO_PLAYER_STATE) {
            return Sy.varEnemyCharacters[i];
        }
    }
    //null character
    return Sy.createEmptyCharacter();
};
//fills Sy.map.move with the movement grid of a character
Sy.fillMove = function (x, y, move, classname, player_state) {
    Sy.map.move[x][y] = move;
    var queue = [];
    queue.push({
        'x': x,
        'y': y,
        'move': move
    });
    while (queue.length) {
        var node = queue.shift();
        if (node.y + 1 < Sy.map.height) {
            var ch = Sy.getCharacterAtPosition(node.x, node.y + 1);
            if (ch.player_state == player_state || ch.player_state == Sy.NO_PLAYER_STATE) {
                var cost = Sy.map.terrain[node.x][node.y + 1].cost;
                cost += Sy.map.terrain[node.x][node.y + 1][classname];
                if (node.move - cost > 0 && Sy.map.move[node.x][node.y + 1] < node.move - cost) {
                    Sy.map.move[node.x][node.y + 1] = node.move - cost;
                    queue.push({
                        'x': node.x,
                        'y': node.y + 1,
                        'move': node.move - cost
                    });
                }
            }
        }
        if (node.y > 0) {
            var ch = Sy.getCharacterAtPosition(node.x, node.y - 1);
            if (ch.player_state == player_state || ch.player_state == Sy.NO_PLAYER_STATE) {
                var cost = Sy.map.terrain[node.x][node.y - 1].cost;
                cost += Sy.map.terrain[node.x][node.y - 1][classname];
                if (node.move - cost > 0 && Sy.map.move[node.x][node.y - 1] < node.move - cost) {
                    Sy.map.move[node.x][node.y - 1] = node.move - cost;
                    queue.push({
                        'x': node.x,
                        'y': node.y - 1,
                        'move': node.move - cost
                    });
                }
            }
        }
        if (node.x + 1 < Sy.map.width) {
            var ch = Sy.getCharacterAtPosition(node.x + 1, node.y);
            if (ch.player_state == player_state || ch.player_state == Sy.NO_PLAYER_STATE) {
                var cost = Sy.map.terrain[node.x + 1][node.y].cost;
                cost += Sy.map.terrain[node.x + 1][node.y][classname];
                if (node.move - cost > 0 && Sy.map.move[node.x + 1][node.y] < node.move - cost) {
                    Sy.map.move[node.x + 1][node.y] = node.move - cost;
                    queue.push({
                        'x': node.x + 1,
                        'y': node.y,
                        'move': node.move - cost
                    });
                }
            }
        }
        if (node.x > 0) {
            var ch = Sy.getCharacterAtPosition(node.x - 1, node.y);
            if (ch.player_state == player_state || ch.player_state == Sy.NO_PLAYER_STATE) {
                var cost = Sy.map.terrain[node.x - 1][node.y].cost;
                cost += Sy.map.terrain[node.x - 1][node.y][classname];
                if (node.move - cost > 0 && Sy.map.move[node.x - 1][node.y] < node.move - cost) {
                    Sy.map.move[node.x - 1][node.y] = node.move - cost;
                    queue.push({
                        'x': node.x - 1,
                        'y': node.y,
                        'move': node.move - cost
                    });
                }
            }
        }
    }
};
//fills Sy.map.attack with the attackable squares of a grid
Sy.fillAttack = function (x, y, min_range, max_range) {
    for (var i = 0; i < max_range + 1; i += 1) {
        for (var j = 0; j + i < max_range + 1; j += 1) {
            if (i + j >= min_range) {
                if (x + i >= 0 && x + i < Sy.map.width && y + j >= 0 && y + j < Sy.map.height) {
                    Sy.map.attack[x + i][y + j] = 1;
                }
                if (x - i >= 0 && x - i < Sy.map.width && y + j >= 0 && y + j < Sy.map.height) {
                    Sy.map.attack[x - i][y + j] = 1;
                }
                if (x - i >= 0 && x - i < Sy.map.width && y - j >= 0 && y - j < Sy.map.height) {
                    Sy.map.attack[x - i][y - j] = 1;
                }
                if (x + i >= 0 && x + i < Sy.map.width && y - j >= 0 && y - j < Sy.map.height) {
                    Sy.map.attack[x + i][y - j] = 1;
                }
            }
        }
    }
}
//given a character, fills the map and attack grids with that character's info
Sy.fillMoveAndAttackForCharacter = function (ch) {
    Sy.fillMove(ch.x, ch.y, ch.mov + 1, ch.cl, ch.player_state);
    for (var c = 0; c < 5; c += 1) {
        var item = ch.item[c];
        if (item.uses > 0 && item.menu_option == Sy.MENU_ATTACK) {
            for (var i = 0; i < Sy.map.width; i += 1) {
                for (var j = 0; j < Sy.map.height; j += 1) {
                    var possibleCh = Sy.getCharacterAtPosition(i, j);
                    if ((possibleCh.player_state == Sy.NO_PLAYER_STATE || (possibleCh.x == ch.x && possibleCh.y == ch.y)) && Sy.map.move[i][j] != 0 && ch[item.kind + "_exp"] >= item.rank) {
                        Sy.fillAttack(i, j, item.min_range, item.max_range);
                    }
                }
            }
        }
    }
};
//returns a stack of intermittant steps to a destination on the move map
Sy.getMovementPath = function (fromX, fromY, toX, toY) {
    var movement_path = [
        [toX, toY]
    ];
    var cost = Sy.map.move[toX][toY];
    while (toX != fromX || toY != fromY) {
        if (toX - 1 >= 0) {
            if (Sy.map.move[toX - 1][toY] > cost) {
                cost = Sy.map.move[toX - 1][toY];
                toX -= 1;
                movement_path.push([toX, toY]);
                continue;
            }
        }
        if (toX + 1 < Sy.map.width) {
            if (Sy.map.move[toX + 1][toY] > cost) {
                cost = Sy.map.move[toX + 1][toY];
                toX += 1;
                movement_path.push([toX, toY]);
                continue;
            }
        }
        if (toY - 1 >= 0) {
            if (Sy.map.move[toX][toY - 1] > cost) {
                cost = Sy.map.move[toX][toY - 1];
                toY -= 1;
                movement_path.push([toX, toY]);
                continue;
            }
        }
        if (toY + 1 < Sy.map.height) {
            if (Sy.map.move[toX][toY + 1] > cost) {
                cost = Sy.map.move[toX][toY + 1];
                toY += 1;
                movement_path.push([toX, toY]);
                continue;
            }
        }
    }
    return movement_path;
};
//returns an array of units that are currently overlapping the attack grid
Sy.getUnitsInWeaponRange = function (state) {
    var result = [];
    for (var i = 0; i < Sy.varPlayerCharacters.length; i += 1) {
        if (Sy.varPlayerCharacters[i].player_state == state) {
            if (Sy.map.attack[Sy.varPlayerCharacters[i].x][Sy.varPlayerCharacters[i].y] != 0) {
                result.push(Sy.varPlayerCharacters[i]);
            }
        }
    }
    for (var i = 0; i < Sy.varEnemyCharacters.length; i += 1) {
        if (Sy.varEnemyCharacters[i].player_state == state) {
            if (Sy.map.attack[Sy.varEnemyCharacters[i].x][Sy.varEnemyCharacters[i].y] != 0) {
                result.push(Sy.varEnemyCharacters[i]);
            }
        }
    }
    return result;
};
//deals damage to each character based on their weapons, returns battle outcome
Sy.performBattleCalculation = function (character1, weapon1, character2, weapon2) {
    var preview = Sy.battlePreview(character1, weapon1, character2, weapon2);
    var ret = {
        player: {},
        enemy: {},
        damage: []
    };
    ret.player.rounds = 0;
    ret.enemy.rounds = 0;
    //"attack","crit","miss'
    ret.player.desc = [];
    ret.enemy.desc = [];
    //note: crit not random otherwise out of synch
    if (preview.player.rounds > 0) {
        preview.player.rounds -= 1;
        ret.player.rounds += 1;
        if (preview.player.hit > Sy.PRNG.random() * 100) {
            if (preview.player.crit < Sy.PRNG.random() * 100) {
                character2.currentHp -= preview.player.damage;
                ret.damage.push(preview.player.damage);
                ret.player.desc.push("attack");
            } else {
                ret.player.desc.push("crit");
                character2.currentHp -= preview.player.damage * 3;
                ret.damage.push(preview.player.damage * 3);
            }
        } else {
            ret.player.desc.push("miss");
            ret.damage.push(0);
        }
    }
    if (preview.enemy.rounds > 0 && character2.currentHp > 0 && character1.currentHp > 0) {
        preview.enemy.rounds -= 1;
        ret.enemy.rounds += 1;
        if (preview.enemy.hit > Sy.PRNG.random() * 100) {
            if (preview.enemy.crit < Sy.PRNG.random() * 100) {
                character1.currentHp -= preview.enemy.damage;
                ret.damage.push(preview.enemy.damage);
                ret.enemy.desc.push("attack");
            } else {
                ret.enemy.desc.push("crit");
                character1.currentHp -= preview.enemy.damage * 3;
                ret.damage.push(preview.enemy.damage * 3);
            }
        } else {
            ret.enemy.desc.push("miss");
            ret.damage.push(0);
        }
    }
    if (preview.player.rounds > 0 && character2.currentHp > 0 && character1.currentHp > 0) {
        preview.player.rounds -= 1;
        ret.player.rounds += 1;
        if (preview.player.hit > Sy.PRNG.random() * 100) {
            if (preview.player.crit < Sy.PRNG.random() * 100) {
                character2.currentHp -= preview.player.damage;
                ret.damage.push(preview.player.damage);
                ret.player.desc.push("attack");
            } else {
                ret.player.desc.push("crit");
                character2.currentHp -= preview.player.damage * 3;
                ret.damage.push(preview.player.damage * 3);
            }
        } else {
            ret.player.desc.push("miss");
            ret.damage.push(0);
        }
    }
    if (preview.enemy.rounds > 0 && character2.currentHp > 0 && character1.currentHp > 0) {
        preview.enemy.rounds -= 1;
        ret.enemy.rounds += 1;
        if (preview.enemy.hit > Sy.PRNG.random() * 100) {
            if (preview.enemy.crit < Sy.PRNG.random() * 100) {
                character1.currentHp -= preview.enemy.damage;
                ret.damage.push(preview.enemy.damage);
                ret.enemy.desc.push("attack");
            } else {
                ret.enemy.desc.push("crit");
                character1.currentHp -= preview.enemy.damage * 3;
                ret.damage.push(preview.enemy.damage);
            }
        } else {
            ret.enemy.desc.push("miss");
            ret.damage.push(0);
        }
    }
    if (character2.currentHp < 1) {
        character2.player_state = Sy.NO_PLAYER_STATE;
    }
    if (character1.currentHp < 1) {
        character1.player_state = Sy.NO_PLAYER_STATE;
    }
    return ret;
};
//returns an object with damage, hit, rounds, crit rates and weapon name for both caracters
Sy.battlePreview = function (character1, weapon1, character2, weapon2) {
    var ret = {
        player: {},
        enemy: {}
    };
    //perform calculations here
    var playerDmg = (character1.str);
    if (playerDmg > character1.max_str) {
        playerDmg = character1.max_str;
    }
    for (var i = 0; i < weapon1.effective_against.length; i += 1) {
        if (weapon1.effective_against[i] == character2.cl) {
            playerDmg += weapon1.might;
            playerDmg += weapon1.might;
        }
    }
    playerDmg += weapon1.might;
    var enemyDef = (character2.def);
    if (enemyDef > character1.max_def) {
        enemyDef = character1.max_def;
    }
    playerDmg -= enemyDef;
    playerDmg -= Sy.map.terrain[character2.x][character2.y].def;
    if (playerDmg < 1) {
        playerDmg = 0;
    }
    //--//
    var enemyDmg = (character2.str);
    if (enemyDmg > character2.max_str) {
        enemyDmg = character2.max_str;
    }
    for (var i = 0; i < weapon2.effective_against.length; i += 1) {
        if (weapon2.effective_against[i] == character1.cl) {
            enemyDmg += weapon2.might;
            enemyDmg += weapon2.might;
        }
    }
    enemyDmg += weapon1.might;
    var playerDef = (character1.def);
    if (playerDef > character1.max_def) {
        playerDef = character1.max_def;
    }
    enemyDmg -= playerDef;
    enemyDmg -= Sy.map.terrain[character1.x][character1.y].def;
    if (enemyDmg < 1) {
        enemyDmg = 0;
    }
    if (weapon1.name != "none") {
        ret.player.damage = playerDmg;
    } else {
        ret.player.damage = 0;
    }
    if (weapon2.name != "none") {
        ret.enemy.damage = enemyDmg;
    } else {
        ret.enemy.damage = 0;
    }
    var playerSkill = (character1.skl);
    if (playerSkill > character1.max_skl) {
        playerSkill = character1.max_skl;
    }
    var playerLuck = (character2.lck);
    if (playerLuck > character2.max_lck) {
        playerLuck = character2.max_lck;
    }
    var enemySkill = (character2.skl);
    if (enemySkill > character2.max_skl) {
        enemySkill = character2.max_skl;
    }
    var enemyLuck = (character2.lck);
    if (enemyLuck > character2.max_lck) {
        enemyLuck = character2.max_lck;
    }
    var playerSpeed = (character1.spd);
    if (playerSpeed > character1.max_spd) {
        playerSpeed = character1.max_spd;
    }
    var enemySpeed = (character2.spd);
    if (enemySpeed > character2.max_spd) {
        enemySpeed = character2.max_spd;
    }
    var playerHit = weapon1.hit + playerSkill + Math.floor(playerLuck / 2) - (enemySpeed * 2 + enemyLuck - weapon2.weight);
    if (playerHit < 1) {
        playerHit = 0;
    }
    var enemyHit = weapon2.hit + enemySkill + Math.floor(enemyLuck / 2) - (playerSpeed * 2 + playerLuck - weapon1.weight);
    if (enemyHit < 1) {
        enemyHit = 0;
    }
    ret.player.rounds = 1;
    ret.enemy.rounds = 1;
    if (playerSpeed - enemySpeed >= 4) {
        ret.player.rounds = 2;
    }
    if (enemySpeed - playerSpeed >= 4) {
        ret.enemy.rounds = 2;
    }
    if (weapon1.name != "none") {
        ret.player.hit = playerHit;
    } else {
        ret.player.hit = 0;
        ret.player.crit = 0;
        ret.player.damage = 0;
        ret.player.rounds = 0;
    }
    if (weapon2.name != "none") {
        ret.enemy.hit = enemyHit;
    } else {
        ret.enemy.hit = 0;
        ret.enemy.crit = 0;
        ret.enemy.damage = 0;
        ret.enemy.rounds = 0;
    }
    ret.player.crit = weapon1.crit + Math.floor(playerSkill / 2);
    ret.enemy.crit = weapon2.crit + Math.floor(enemySkill / 2);
    ret.player.weapon = weapon1.kind;
    ret.enemy.weapon = weapon2.kind;
    return ret;
};
//uses an item, altering the supplied character
Sy.useItem = function (character, item) {
    if (item.name == "Vulnerary") {
        character.currentHp += item.might;
        if (character.currentHp > character.hp) {
            character.currentHp = character.hp;
        }
    }
};
//use a staff, altering the target
Sy.useStaff = function (source, target, item) {
    if (item.name == "Heal") {
        target.currentHp = target.hp;
    }
};
//sets a cell to contain the correct background image for the terrain
Sy.autoTile = function (cell, terrainName, x, y) {
    terrainName = terrainName.toLowerCase();
    var cellLeft = "none";
    var cellRight = "none";
    var cellUp = "none";
    var cellDown = "none";
    var cellLeftUp = "none";
    var cellLeftDown = "none";
    var cellRightUp = "none";
    var cellRightDown = "none";
    if (x + 1 < Sy.map.width) {
        cellRight = Sy.map.terrain[x + 1][y].name.toLowerCase();
        if (y + 1 < Sy.map.height) {
            cellRightDown = Sy.map.terrain[x + 1][y + 1].name.toLowerCase();
        }
        if (y - 1 >= 0) {
            cellRightUp = Sy.map.terrain[x + 1][y - 1].name.toLowerCase();
        }
    }
    if (x - 1 >= 0) {
        cellLeft = Sy.map.terrain[x - 1][y].name.toLowerCase();
        if (y + 1 < Sy.map.height) {
            cellLeftDown = Sy.map.terrain[x - 1][y + 1].name.toLowerCase();
        }
        if (y - 1 >= 0) {
            cellLeftUp = Sy.map.terrain[x - 1][y - 1].name.toLowerCase();
        }
    }
    if (y + 1 < Sy.map.height) {
        cellDown = Sy.map.terrain[x][y + 1].name.toLowerCase();
    }
    if (y - 1 >= 0) {
        cellUp = Sy.map.terrain[x][y - 1].name.toLowerCase();
    }
    switch (terrainName) {
    case "plain":
        {
            cell.addClass(terrainName);
            break;
        }
    case "sea":
        {
            cell.addClass(terrainName);
            cell.css({
                "zIndex": "0",
                "backgroundRepeat": "repeat"
            });
            var lookingFor = "sea";
            if (cellUp == lookingFor && cellLeft == lookingFor && cellDown == lookingFor && cellRight == lookingFor) {
                break;
            }
            if (cellUp == lookingFor && cellLeft == lookingFor && cellDown != lookingFor && cellRight == lookingFor) {
                cell.css("backgroundImage", "url(./images/592h.png)");
            }
            if (cellUp != lookingFor && cellLeft == lookingFor && cellDown == lookingFor && cellRight == lookingFor) {
                cell.css("backgroundImage", "url(./images/592.png)");
            }
            if (cellUp == lookingFor && cellLeft == lookingFor && cellDown == lookingFor && cellRight != lookingFor) {
                cell.css("backgroundImage", "url(./images/566h.png)");
            }
            if (cellUp == lookingFor && cellLeft != lookingFor && cellDown == lookingFor && cellRight == lookingFor) {
                cell.css("backgroundImage", "url(./images/566.png)");
            }
            if (cellLeft != lookingFor && cellRight != lookingFor && cellUp == lookingFor && cellDown == lookingFor) {
                cell.css("backgroundImage", "url(./images/450.png)");
            }
            if (cellLeft == lookingFor && cellRight != lookingFor && cellUp != lookingFor && cellDown != lookingFor) {
                cell.css("backgroundImage", "url(./images/a218.png)");
            }
            if (cellLeft != lookingFor && cellRight == lookingFor && cellUp != lookingFor && cellDown != lookingFor) {
                cell.css("backgroundImage", "url(./images/a218h.png)");
            }
            if (cellLeft != lookingFor && cellRight != lookingFor && cellUp != lookingFor && cellDown == lookingFor) {
                cell.css("backgroundImage", "url(./images/472.png)");
            }
            if (cellLeft != lookingFor && cellRight != lookingFor && cellUp == lookingFor && cellDown != lookingFor) {
                cell.css("backgroundImage", "url(./images/472h.png)");
            }
            if (cellDown == lookingFor && cellRight == lookingFor && cellUp != lookingFor && cellLeft != lookingFor) {
                cell.css("backgroundImage", "url(./images/242hv.png)");
            }
            if (cellDown == lookingFor && cellRight != lookingFor && cellUp != lookingFor && cellLeft == lookingFor) {
                cell.css("backgroundImage", "url(./images/242v.png)");
            }
            if (cellDown != lookingFor && cellRight == lookingFor && cellUp == lookingFor && cellLeft != lookingFor) {
                cell.css("backgroundImage", "url(./images/242h.png)");
            }
            if (cellDown != lookingFor && cellRight != lookingFor && cellUp == lookingFor && cellLeft == lookingFor) {
                cell.css("backgroundImage", "url(./images/242.png)");
            }
            break;
        }
    default:
        {
            cell.addClass(terrainName);
        }
    }
};
//sets a given img tag to the correct displayed image
Sy.setImage = function (imgElement, cl, status, player_state) {
    var baseUrl = "./images/";
    cl = cl.toLowerCase().replace(" ", ""); //ch.cl;
    var colour = "red";
    if (player_state == Sy.PLAYER) {
        colour = "blue";
    }
    var finalUrl = (baseUrl + cl + status + colour + ".gif");
    if (finalUrl != imgElement.attr("src")) {
        imgElement.attr("src", finalUrl);
    }
};
//returns the enemy's equipped weapon
Sy.getFirstUseableWeapon = function (enemy, character) {
    //back up the move and attack maps
    var attackBackup = [];
    for (var i = 0; i < Sy.map.width; i += 1) {
        attackBackup.push([]);
        for (var j = 0; j < Sy.map.height; j += 1) {
            attackBackup[i].push(Sy.map.attack[i][j]);
        }
    }
    var enemyWeapon = Im.none;
    for (var c = 0; c < 5; c += 1) {
        var item = enemy.item[c];
        if (item.menu_option == Sy.MENU_ATTACK && enemy[item.kind + "_exp"] >= item.rank) {
            Sy.map.resetAttack();
            Sy.fillAttack(enemy.x, enemy.y, item.min_range, item.max_range);
            var inRange = Sy.getUnitsInWeaponRange(Sy.PLAYER_STATE);
            Sy.map.resetAttack();
            var weaponCanHitPlayer = false;
            for (var i = 0; i < inRange.length; i += 1) {
                if (inRange[i].x == character.x && inRange[i].y == character.y) {
                    weaponCanHitPlayer = true;
                    enemyWeapon = item;
                    break;
                }
            }
            if (weaponCanHitPlayer) {
                break;
            }
        }
    }
    //restore original grid
    for (var i = 0; i < Sy.map.width; i += 1) {
        for (var j = 0; j < Sy.map.height; j += 1) {
            Sy.map.attack[i][j] = attackBackup[i][j];
        }
    }
    return enemyWeapon;
}
//Given a character and a valid attack location, returns (x,y} of a move cell that can attack it
Sy.getMoveCellFromAttack = function (attackX, attackY, ch) {
    var ret = {
        x: 0,
        y: 0
    };
    //backup the attack grid
    var attackBackup = [];
    for (var i = 0; i < Sy.map.width; i += 1) {
        attackBackup.push([]);
        for (var j = 0; j < Sy.map.height; j += 1) {
            attackBackup[i].push(Sy.map.attack[i][j]);
        }
    }
    Sy.map.resetAttack();
    //try each weapon
    for (var c = 0; c < 5; c += 1) {
        var item = ch.item[c];
        if (item.menu_option == Sy.MENU_ATTACK && ch[item.kind + "_exp"] >= item.rank) {
            var found = false;
            //find map locations the unit can move to
            for (var i = 0; i < Sy.map.width; i += 1) {
                for (var j = 0; j < Sy.map.height; j += 1) {
                    //can move here
                    if (Sy.map.move[i][j] != 0 && (Sy.getCharacterAtPosition(i, j).player_state == Sy.NO_PLAYER_STATE || (Sy.getCharacterAtPosition(i, j).x == ch.x && Sy.getCharacterAtPosition(i, j).y == ch.y))) {
                        //fill the attack grid and check that it overlaps with the target
                        Sy.fillAttack(i, j, item.min_range, item.max_range);
                        //see if there are any units in range
                        var inRange = Sy.getUnitsInWeaponRange(Sy.PLAYER);
                        for (var k = 0; k < inRange.length; k += 1) {
                            //check to see if they are the target
                            if (inRange[k].x == attackX && inRange[k].y == attackY) {
                                //found it
                                found = true;
                                ret.x = i;
                                ret.y = j;
                                break;
                            }
                        }
                        Sy.map.resetAttack();
                    }
                    if (found) {
                        break;
                    }
                }
                if (found) {
                    break;
                }
            }
        }
    }
    //restore original grid
    for (var i = 0; i < Sy.map.width; i += 1) {
        for (var j = 0; j < Sy.map.height; j += 1) {
            Sy.map.attack[i][j] = attackBackup[i][j];
        }
    }
    return ret;
};
//AI
Sy.AI = function () {
    var inputSource = Sy.varInputSourceEnemy;
    if (Sy.PLAYER_STATE == Sy.PLAYER) {
        return;
    }
    if (inputSource == Sy.INPUT_SOURCE_AI) {
        //ensure that AI only generates one input per frame
        if (Sy.varInputBuffer.length == 0) {
            /*
      while(AI units left){
        move cursor to AI unit
        -display move
        if nothing in range
        -pretend that the unit can traverse the whole map
        -find a unit in range
        -overlap the real movement and the pretend movement
        -move toward the overlap point
        else
        -choose random target and attack
      }
      */
            switch (Sy.CurrentState) {
            case Sy.STATE_IDLE:
                {
                    var nextUnit = -1;
                    for (var i = 0; i < Sy.varEnemyCharacters.length; i += 1) {
                        if (!(Sy.varEnemyCharacters[i].hasMoved) && Sy.varEnemyCharacters[i].player_state == Sy.PLAYER_STATE && Sy.varEnemyCharacters[i].currentHp > 0) {
                            nextUnit = i;
                            break;
                        }
                    }
                    if (nextUnit < 0) {
                        Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                    } else {
                        if (Sy.map.cursorX == Sy.varEnemyCharacters[nextUnit].x && Sy.map.cursorY == Sy.varEnemyCharacters[nextUnit].y) {
                            //select that character
                            Sy.AIdata.targetX = -1;
                            Sy.AIdata.targetY = -1;
                            Sy.AIdata.ch = Sy.varEnemyCharacters[nextUnit];
                            Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                            nextUnit = -1;
                            return;
                        } else {
                            //move cursor towards that character
                            Sy.moveCursorToPosition(Sy.varEnemyCharacters[nextUnit].x, Sy.varEnemyCharacters[nextUnit].y);
                            return;
                        }
                    }
                    break;
                }
            case Sy.STATE_DISPLAY_MOVE:
                {
                    if (Sy.AIdata.targetX == -1 && Sy.AIdata.targetY == -1) {
                        Sy.AIdata.unitsInRange = [];
                        for (var i = 0; i < Sy.map.width; i += 1) {
                            for (var j = 0; j < Sy.map.height; j += 1) {
                                if (Sy.map.attack[i][j] == 1) {
                                    var ch = Sy.getCharacterAtPosition(i, j);
                                    if (ch.player_state != Sy.NO_PLAYER_STATE && ch.player_state != Sy.PLAYER_STATE) {
                                        Sy.AIdata.unitsInRange.push(Sy.getCharacterAtPosition(i, j));
                                    }
                                }
                            }
                        }
                        if (Sy.AIdata.unitsInRange.length < 1) {
                            //no units in range, move toward them
                            //back up the move and attack maps
                            var attackBackup = [];
                            var moveBackup = [];
                            for (var i = 0; i < Sy.map.width; i += 1) {
                                attackBackup.push([]);
                                moveBackup.push([]);
                                for (var j = 0; j < Sy.map.height; j += 1) {
                                    attackBackup[i].push(Sy.map.attack[i][j]);
                                    moveBackup[i].push(Sy.map.move[i][j]);
                                }
                            }
                            Sy.map.resetAttack();
                            Sy.map.resetMove();
                            //increase movement and fill the map
                            var movementBackup = Sy.AIdata.ch.mov;
                            Sy.AIdata.ch.mov = Sy.map.width + Sy.map.height;
                            Sy.fillMoveAndAttackForCharacter(Sy.AIdata.ch);
                            Sy.AIdata.ch.mov = movementBackup;
                            //scan through characters and try to find a target in range
                            var tempUnitsInRange = [];
                            for (var i = 0; i < Sy.map.width; i += 1) {
                                for (var j = 0; j < Sy.map.height; j += 1) {
                                    if (Sy.map.attack[i][j] == 1) {
                                        var ch = Sy.getCharacterAtPosition(i, j);
                                        if (ch.player_state != Sy.NO_PLAYER_STATE && ch.player_state != Sy.PLAYER_STATE) {
                                            tempUnitsInRange.push(Sy.getCharacterAtPosition(i, j));
                                        }
                                    }
                                }
                            }
                            var tempPathList = [];
                            if (tempUnitsInRange.length == 0) {
                                //can't attack anything, e.g. units alive are over water, set to wait
                                Sy.AIdata.targetX = Sy.AIdata.ch.x;
                                Sy.AIdata.targetY = Sy.AIdata.ch.y;
                            } else {
                                //compute the destination cell (a cell that an attack can be launched from)
                                var attackPosition = Sy.getMoveCellFromAttack(tempUnitsInRange[0].x, tempUnitsInRange[0].y, Sy.AIdata.ch);
                                //get the movement path to this cell
                                tempPathList = Sy.getMovementPath(Sy.AIdata.ch.x, Sy.AIdata.ch.y, attackPosition.x, attackPosition.y);
                            }
                            //restore original grid
                            for (var i = 0; i < Sy.map.width; i += 1) {
                                for (var j = 0; j < Sy.map.height; j += 1) {
                                    Sy.map.attack[i][j] = attackBackup[i][j];
                                    Sy.map.move[i][j] = moveBackup[i][j];
                                }
                            }
                            //work back from target, until it hits a cell that the AI can move to
                            var lastMove = Sy.AIdata.ch.mov;
                            if (tempPathList.length > 0) {
                                for (var i = tempPathList.length - 1; i >= 0; i -= 1) {
                                    var tempX = tempPathList[i][0];
                                    var tempY = tempPathList[i][1];
                                    if (Sy.map.move[tempX][tempY] != 0) {
                                        if (Sy.getCharacterAtPosition(tempX, tempY).player_state == Sy.NO_PLAYER_STATE) {
                                            Sy.AIdata.targetX = tempX;
                                            Sy.AIdata.targetY = tempY;
                                            lastMove = Sy.map.move[tempX][tempY];
                                        } else { //a unit is sitting on the deisred path, try deviate around it
                                            for (var xdeviation = -1; xdeviation < 2; xdeviation += 1) {
                                                for (var ydeviation = -1; ydeviation < 2; ydeviation += 1) {
                                                    if (tempX + xdeviation >= 0 && tempY + ydeviation >= 0 && tempX + xdeviation < Sy.map.width && tempY + ydeviation < Sy.map.height) {
                                                        if (Sy.map.move[tempX + xdeviation][tempY + ydeviation] != 0 && Sy.map.move[tempX + xdeviation][tempY + ydeviation] < lastMove && Sy.getCharacterAtPosition(tempX + xdeviation, tempY + ydeviation).player_state == Sy.NO_PLAYER_STATE) {
                                                            Sy.AIdata.targetX = tempX + xdeviation;
                                                            Sy.AIdata.targetY = tempY + ydeviation;
                                                            lastMove = Sy.map.move[tempX + xdeviation][tempY + ydeviation];
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                            }
                        } else {
                            //attack a random target
                            var unitToAttack = Math.floor(Sy.PRNG.random() * Sy.AIdata.unitsInRange.length);
                            unitToAttack = Sy.AIdata.unitsInRange[unitToAttack];
                            //back up the move and attack maps
                            var attackBackup = [];
                            for (var i = 0; i < Sy.map.width; i += 1) {
                                attackBackup.push([]);
                                for (var j = 0; j < Sy.map.height; j += 1) {
                                    attackBackup[i].push(Sy.map.attack[i][j]);
                                }
                            }
                            Sy.map.resetAttack();
                            var attackPosition = Sy.getMoveCellFromAttack(unitToAttack.x, unitToAttack.y, Sy.AIdata.ch);
                            Sy.AIdata.targetX = attackPosition.x;
                            Sy.AIdata.targetY = attackPosition.y;
                            //restore original grid
                            for (var i = 0; i < Sy.map.width; i += 1) {
                                for (var j = 0; j < Sy.map.height; j += 1) {
                                    Sy.map.attack[i][j] = attackBackup[i][j];
                                }
                            }
                        }
                    } else {
                        if (Sy.map.cursorX == Sy.AIdata.targetX && Sy.map.cursorY == Sy.AIdata.targetY) {
                            //select that character
                            Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                            Sy.AIdata.pressA = true;
                            return;
                        } else {
                            //move to attack location
                            Sy.moveCursorToPosition(Sy.AIdata.targetX, Sy.AIdata.targetY);
                        }
                    }
                    break;
                }
            case Sy.STATE_POST_MOVE_MENU:
                {
                    //scroll through the menu until get to wait or attack
                    var option = Sy.internalStateVar[Sy.CurrentState].menu[Sy.internalStateVar[Sy.CurrentState].selectedOption];
                    if (option == "attack" || option == "wait") {
                        Sy.AIdata.pressA = true;
                        Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                        return;
                    } else {
                        Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_DOWN]);
                        return;
                    }
                    break;
                }
            case Sy.STATE_SELECT_WEAPON_MENU:
                {
                    //try all the options until there is a weapon that works
                    if (Sy.AIdata.pressA) {
                        Sy.AIdata.pressA = false;
                        Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                        return;
                    } else {
                        Sy.AIdata.pressA = true;
                        Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_DOWN]);
                        return;
                    }
                    break;
                }
            case Sy.STATE_SELECT_WEAPON_TARGET:
                {
                    //May not necessarily be the original target. Target was random though, so it makes no difference
                    Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                    break;
                }
            case Sy.STATE_DISPLAY_MENU:
                {
                    //scroll through the menu until get to end turn
                    var option = Sy.internalStateVar[Sy.CurrentState].menu[Sy.internalStateVar[Sy.CurrentState].selectedOption];
                    if (option == "End Turn") {
                        Sy.AIdata.pressA = true;
                        Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                        return;
                    } else {
                        Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_DOWN]);
                        return;
                    }
                    break;
                }
            }
        }
    }
};
//AI, generates CPU input to move the cursor to a position
Sy.moveCursorToPosition = function (x, y) {
    if (Sy.map.cursorX != x) {
        if (Sy.map.cursorX > x) {
            Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_LEFT]);
            return;
        }
        if (Sy.map.cursorX < x) {
            Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_RIGHT]);
            return;
        }
    }
    if (Sy.map.cursorY != y) {
        if (Sy.map.cursorY > y) {
            Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_UP]);
            return;
        }
        if (Sy.map.cursorY < y) {
            Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_DOWN]);
            return;
        }
    }
};
//creates a DOM element at the desired position, updating it if one already exists, returns the element
Sy.putTextAtPosition = function (x, y, elementId, elementText, appendTo) {
    if ($("#" + String(elementId)).length) {
        $("#" + String(elementId)).remove();
    }
    var stimg = $("<div style='position:absolute;'></div>");
    stimg.attr("id", String(elementId));
    $("#" + String(appendTo)).append(stimg);
    stimg.text(String(elementText));
    stimg.offset({
        left: x,
        top: y
    });
    return stimg;
};
//keyboard input
Sy.handleLocalInput = function (e) {
    var inputSource = Sy.INPUT_SOURCE_KEYBOARD;
    if (Sy.PLAYER_STATE == Sy.PLAYER) {
        inputSource = Sy.varInputSourcePlayer;
    } else {
        inputSource = Sy.varInputSourceEnemy;
    }
    if (inputSource == Sy.INPUT_SOURCE_KEYBOARD) {
        if (Sy.varInputBuffer.length == 0) {
            if (e.keyCode == 90) { //b 
                if (Sy.CurrentState != Sy.STATE_MOVE_ANIMATION && Sy.CurrentState != Sy.STATE_DISPLAY_STAFF_ANIMATION && Sy.CurrentState != Sy.STATE_USE_ITEM_ANIMATION && Sy.CurrentState != Sy.STATE_BATTLE) {
                    Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_B]);
                }
            }
            if (e.keyCode == 65) { //a
                if (Sy.CurrentState != Sy.STATE_MOVE_ANIMATION && Sy.CurrentState != Sy.STATE_DISPLAY_STAFF_ANIMATION && Sy.CurrentState != Sy.STATE_USE_ITEM_ANIMATION && Sy.CurrentState != Sy.STATE_BATTLE && Sy.CurrentState != Sy.STATE_DISPLAY_TURN) {
                    Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_A]);
                }
            }
            if (e.keyCode == 37) { //left
                if (Sy.CurrentState != Sy.STATE_MOVE_ANIMATION && Sy.CurrentState != Sy.STATE_DISPLAY_STAFF_ANIMATION && Sy.CurrentState != Sy.STATE_USE_ITEM_ANIMATION && Sy.CurrentState != Sy.STATE_BATTLE && Sy.CurrentState != Sy.STATE_DISPLAY_TURN) {
                    Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_LEFT]);
                }
                return false;
            }
            if (e.keyCode == 38) { //up
                if (Sy.CurrentState != Sy.STATE_MOVE_ANIMATION && Sy.CurrentState != Sy.STATE_DISPLAY_STAFF_ANIMATION && Sy.CurrentState != Sy.STATE_USE_ITEM_ANIMATION && Sy.CurrentState != Sy.STATE_BATTLE && Sy.CurrentState != Sy.STATE_DISPLAY_TURN) {
                    Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_UP]);
                }
                return false;
            }
            if (e.keyCode == 39) { //right
                if (Sy.CurrentState != Sy.STATE_MOVE_ANIMATION && Sy.CurrentState != Sy.STATE_DISPLAY_STAFF_ANIMATION && Sy.CurrentState != Sy.STATE_USE_ITEM_ANIMATION && Sy.CurrentState != Sy.STATE_BATTLE && Sy.CurrentState != Sy.STATE_DISPLAY_TURN) {
                    Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_RIGHT]);
                }
                return false;
            }
            if (e.keyCode == 40) { //down
                if (Sy.CurrentState != Sy.STATE_MOVE_ANIMATION && Sy.CurrentState != Sy.STATE_DISPLAY_STAFF_ANIMATION && Sy.CurrentState != Sy.STATE_USE_ITEM_ANIMATION && Sy.CurrentState != Sy.STATE_BATTLE && Sy.CurrentState != Sy.STATE_DISPLAY_TURN) {
                    Sy.varInputBuffer.push([Sy.CurrentState, Sy.BUTTON_DOWN]);
                }
                return false;
            }
        }
    }
    return false;
};
//initalise the document
$(window).load(Sy.init);